﻿// MusicComposer by Charles Petzold, January 2010
using System;
using System.Windows;
using System.Windows.Controls;
using Petzold.Midi;

namespace MusicComposer
{
    public partial class Window1 : Window
    {
        MidiStringPlayer player;

        public Window1()
        {
            InitializeComponent();
            txtbox.Text = "C4 E4 G4 C5";

            player = new MidiStringPlayer();
            player.Ended += OnMidiStringPlayerEnded;
            player.Failed += OnMidiStringPlayerFailed;
        }

        void OnTextBoxTextChanged(object sender, TextChangedEventArgs args)
        {
            errorTextBlock.Text = "";
        }

        void OnPlayClick(object sender, RoutedEventArgs e)
        {
            playButton.IsEnabled = false;
            stopButton.IsEnabled = true;

            player.MidiString = txtbox.Text;
            player.Play();
        }

        void OnStopClick(object sender, RoutedEventArgs e)
        {
            player.Stop();

            playButton.IsEnabled = true;
            stopButton.IsEnabled = false;
        }

        void OnMidiStringPlayerEnded(object sender, EventArgs args)
        {
            playButton.IsEnabled = true;
            stopButton.IsEnabled = false;
        }

        void OnMidiStringPlayerFailed(object sender, MidiStringPlayerFailedEventArgs args)
        {
            errorTextBlock.Text = args.Error + " in token at offset " + args.Index;
            txtbox.CaretIndex = args.Index;
            playButton.IsEnabled = true;
            stopButton.IsEnabled = false; 

            txtbox.Focus();
        }
    }
}
